%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

%define _disable_ld_no_undefined 1
%define generate_rpmpriorities 0
%define comps %{_datadir}/comps/%{_build_arch}/comps.xml

#global __debug_package {nil}

%define aptver 0.5.15lorg3.95
%define snapver git522
%define srcver %{aptver}.%{snapver}
%define Werror_cflags %nil

%define _lib_name	%{name}-pkg
%define lib_name_orig	lib%{_lib_name}
%define major		0
%define libname		%mklibname %_lib_name %major
%define libnamedevel	%mklibname %_lib_name %major -d

%define _requires_exceptions rpmlib(PayloadIsLzma)\\|devel(linux-

Summary: Debian's Advanced Packaging Tool with RPM support
Name: apt
Version: %{aptver}
Release: %mkrel 28
Group: System/Configuration/Packaging
URL: http://apt-rpm.org/
License: GPLv2+ 
Source0: http://apt-rpm.org/testing/%{name}-%{srcver}.tar.xz

# user editable template configs
Source1: apt.conf
Source3: vendors.list
Source4: apt_preferences

# rpmpriorities generated + manually tweaked from comps.xml core group
Source5: rpmpriorities
Source19: comps2prio.xsl

# Sources 50-99 are for Lua-scripts not in contrib/
Source51: upgradevirt.lua
Source52: gpg-check.lua

# 150-199 for apt.conf.d
# "factory defaults"
Source150: default.conf


Patch1:     apt-0.5.15lorg3.x-cache-corruption.patch
Patch2:     apt-0.5.15lorg3.95-narrowing-conv.patch
Patch3:     apt-0.5.15lorg3.95-lua53.patch
Patch7:     apt-0.5.15lorg3.95-lua52.patch
Patch8:     apt-0.5.15lorg3.95-lua-54.patch
Patch4:     apt-0.5.15lorg3.95-format-security.patch
Patch5:     apt-0.5.15lorg3.95-modemuncher.patch
Patch6:     big_id.patch
Patch200:   apt-0.5.15lorg3.95-gcc47.patch
Patch210:   apt-0.5.15lorg3.95.git522-revert-mass-constify-rpmhandler-getter-methods.patch
Patch220:   apt-0.5.15lorg3.95-revert-genbasedir.patch
Patch221:   acquire-method.cc.security.patch
Patch223:   apt-0.5.15lorg3.95-rpm481c.patch
Patch224:   apt-0.5.15lorg3.95.git522-suggest.patch
Patch226:   apt-0.5.15lorg3.95-chack-string-size.patch
Patch227:   apt-0.5.15lorg3.95-warn-on-new-index.patch
Patch228:   apt-0.5.15lorg3.95-speed-depcache.patch
Patch229:   apt-0.5.15lorg3.95-genbasedir.patch
Patch230:   apt-0.5.15lorg3.95-new-apt-repo-tools.patch
Patch231:   apt-0.5.15lorg3.95-rpm4.18.x.patch
Patch232:   apt-0.5.15lorg3.95-support-sqlite-ndb.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

# TODO: verify the required minimum Python version
BuildRequires: python-devel >= 2.2
BuildRequires: libxml2-devel
BuildRequires: lib64sqlite3-devel
BuildRequires: rpm-devel
BuildRequires: zlib-devel
BuildRequires: bzip2-devel
BuildRequires: libstdc++-devel
BuildRequires: gettext
BuildRequires: perl
BuildRequires: readline-devel
BuildRequires: ncurses-devel
BuildRequires: gawk
BuildRequires: swig
%if %{generate_rpmpriorities}
BuildRequires: %{_bindir}/xsltproc
BuildRequires: %{comps}
%endif
BuildRequires: pkgconfig
BuildRequires: lib64lua5.2-devel
BuildRequires: autoconf, automake
Requires: gnupg
Requires: bzip2
Requires(post): chkconfig
Requires(post): ldconfig
Requires(preun): chkconfig
Requires(pre): %{_lib}rpm1 > 4.11.3
Requires(pre): rpm > 4.11.3
Requires: %{libname} >= %version-%release
Requires: apt-sources-list

%description
APT-RPM is a port of Debian's apt tools for RPM based distributions.
It provides the apt-get utility that provides a simple, safe way to
install and upgrade packages. APT features complete installation
ordering, multiple source capability and several other useful
features.

%package -n %{libname}
Summary:	Libraries for %{name}
Group:		System/Libraries
Provides:	%{lib_name_orig} = %{version}-%{release}
Requires:   	%name-common >= %version
Obsoletes:	libapt0.5
Provides:   	libapt0.5

%description -n %{libname}
This package contains APT's libapt-pkg package manipulation library
modified for RPM.

%package -n %{libnamedevel}
Summary:	Development files for %{name}
Group:		Development/Libraries
Requires:	%{libname} = %{version}-%{release}
Provides:	%{lib_name_orig}-devel
Obsoletes:	libapt0.5-devel
Provides:   	libapt0.5-devel

%description -n %{libnamedevel}
This package contains the header files and static libraries for
developing with APT's libapt-pkg package manipulation library,
modified for RPM.

%package python
Summary: Python bindings for libapt-pkg
Group: Development/Python
Requires: %{name} = %{version}-%{release}

%description python
The apt-python package contains a module which allows python programs
to access the APT library interface.

%package common
Summary:	Common file for %{name} frontend
Group:		System/Configuration/Packaging

%description common
This package contains the needed files for various apt-frontend, 
such as synaptic, aptitude.

%prep
%setup -q -n %{name}-%{srcver}

%patch1 -p0 -b .mmap
%patch2 -p1 -b .narrowing
#patch3 -p1 -b .lua53
%patch4 -p1 -b .format-security
%patch5 -p1 -b .modemuncher
%patch7 -p1 -b .lua52
#patch8 -p1 -b .lua54
%patch6 -p1 -b .id
%patch200 -p1 -b .gcc47
%patch210 -p1 -b .methods
%patch220 -p1 -b .genbasedir
%patch221 -p1 -b .security
%patch223 -p1 -b .481c
%patch224 -p1 -b .suggest
%patch226 -p1 -b .string
%patch227 -p1 -b .warn
%patch228 -p1 -b .speed
%patch229 -p1 -b .genbasedir2
%patch230 -p1 -b .new
%patch231 -p1 -b .rpm418
%patch232 -p1 -b .sqlite-ndb

install -pm 644 %{SOURCE19} comps2prio.xsl

# don't require python, lua etc because of stuff in doc/contrib
find contrib/ -type f | xargs chmod 0644

%build
autoreconf -fiv
#export CXXFLAGS="%{optflags} -D_RPM_4_4_COMPAT -Wno-deprecated-declarations"
%configure2_5x \
    --disable-dependency-tracking \
    --disable-static
make %{?_smp_mflags}

make -C python %{?_smp_mflags} PYTHON="%{__python}"
python -O -c "import py_compile; py_compile.compile('python/apt.py')"

cp -p %{SOURCE5} rpmpriorities

%if %{generate_rpmpriorities}
xsltproc -o rpmpriorities comps2prio.xsl %{comps}
%endif

%install
rm -rf %{buildroot}

make install DESTDIR=%{buildroot} includedir=%{_includedir}/apt-pkg
%find_lang %{name}

# The state files
mkdir -p %{buildroot}%{_localstatedir}/cache/apt/archives/partial
mkdir -p %{buildroot}%{_localstatedir}/cache/apt/genpkglist
mkdir -p %{buildroot}%{_localstatedir}/cache/apt/gensrclist
mkdir -p %{buildroot}%{_localstatedir}/lib/apt/lists/partial

# The config files
mkdir -p %{buildroot}%{_sysconfdir}/apt
mkdir -p %{buildroot}%{_sysconfdir}/apt/apt.conf.d
mkdir -p %{buildroot}%{_sysconfdir}/apt/sources.list.d
mkdir -p %{buildroot}%{_sysconfdir}/apt/vendors.list.d
install -pm 644 %{SOURCE1} %{buildroot}/%{_sysconfdir}/apt/apt.conf
install -pm 644 %{SOURCE3} %{buildroot}/%{_sysconfdir}/apt/vendors.list
install -pm 644 %{SOURCE4} %{buildroot}/%{_sysconfdir}/apt/preferences
install -pm 644 rpmpriorities %{buildroot}/%{_sysconfdir}/apt/

# install config parts
install -pm 644 %{SOURCE150} %{buildroot}%{_sysconfdir}/apt/apt.conf.d/

# Lua scripts
mkdir -p %{buildroot}%{_datadir}/apt/scripts
for script in %{SOURCE51} %{SOURCE52} ; do
 install -pm 755 $script %{buildroot}%{_datadir}/apt/scripts
done

# The python bindings
mkdir -p %{buildroot}%{python_sitearch}/
install -pm 755 python/_apt.so %{buildroot}%{python_sitearch}/
install -pm 644 python/apt.py* %{buildroot}%{python_sitearch}/
touch %{buildroot}%{python_sitearch}/apt.pyo

# Nightly updater scripts & default config
install -Dpm 755 contrib/apt-cron/apt.init %{buildroot}/%{_initrddir}/apt
install -Dpm 755 contrib/apt-cron/apt.cron %{buildroot}/%{_sysconfdir}/cron.daily/apt.cron
install -Dpm 644 contrib/apt-cron/apt.sysconfig %{buildroot}/%{_sysconfdir}/sysconfig/apt

# nuke .la files
rm -f %{buildroot}%{_libdir}/*.la
rm -rf %{buildroot}/usr/lib/debug

#new apt style link
ln -fs %{_bindir}/apt-get %buildroot/%{_bindir}/apt


%clean
rm -rf %{buildroot}

%post
/sbin/ldconfig
/sbin/chkconfig --add apt

%preun
if [ $1 -eq 0 ] ; then
 %{_initrddir}/apt stop &>/dev/null || :
 /sbin/chkconfig --del apt
fi

%postun
/sbin/ldconfig

%posttrans
#drop grub
perl -pi -e "s|grub||" %{_sysconfdir}/apt/rpmpriorities

%files -f %{name}.lang
%defattr(-, root, root)
%{_bindir}/apt-cache
%{_bindir}/apt-cdrom
%{_bindir}/apt-config
%{_bindir}/apt-shell
%{_bindir}/apt-get
%{_bindir}/apt
%{_bindir}/countpkglist
%{_bindir}/genpkglist
%{_bindir}/gensrclist
%{_bindir}/genbasedir
%{_mandir}/man[58]/*.[58]*


%files common
%defattr(-, root, root)
%{_libdir}/apt/
%{_localstatedir}/cache/apt/
%{_localstatedir}/lib/apt/
%dir %{_sysconfdir}/apt/
%config(noreplace) %{_sysconfdir}/apt/apt.conf
%config(noreplace) %{_sysconfdir}/apt/preferences
%config(noreplace) %{_sysconfdir}/apt/vendors.list
%config(noreplace) %{_sysconfdir}/apt/rpmpriorities

%dir %{_sysconfdir}/apt/apt.conf.d/

%config %{_sysconfdir}/apt/apt.conf.d/default.conf
%config %{_sysconfdir}/apt/apt.conf.d/multilib.conf

%dir %{_sysconfdir}/apt/sources.list.d/
%dir %{_sysconfdir}/apt/vendors.list.d/

%config(noreplace) %{_sysconfdir}/sysconfig/apt
%{_sysconfdir}/cron.daily/apt.cron
%{_initrddir}/apt

%dir %{_datadir}/apt/
%dir %{_datadir}/apt/scripts/
%{_datadir}/apt/scripts/gpg-check.lua
%{_datadir}/apt/scripts/upgradevirt.lua


%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/*.so.*
#/usr/lib/debug/*
#/usr/lib/debug/.build-id
#exclude /usr/src/

%files -n %{libnamedevel}
%defattr(-,root,root)
%{_includedir}/apt-pkg
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc

%files python
%defattr(-,root,root,-)
%{python_sitearch}/_apt.so
%{python_sitearch}/apt.py*


%changelog
* Mon Sep 09 2023 yodelu - 0.5.15lorg3.95-28pclos2023
- add p232 (sqlite and ndb support)

* Wed Aug 23 2023 yodelu - 0.5.15lorg3.95-27pclos2023
- add p231

* Wed Aug 03 2023 yodelu - 0.5.15lorg3.95-26pclos2023
- add p230 - new genbasedir (+drop compat mode again)

* Tue Jul 25 2023 yodelu - 0.5.15lorg3.95-25pclos2023
- replace p229 

* Mon Jul 24 2023 yodelu - 0.5.15lorg3.95-24pclos2023
- drop compat-mode >>> rediff and apply p229

* Fri Jul 21 2023 yodelu - 0.5.15lorg3.95-23pclos2023
- remove p222 and p225
- source p229 untill we figure-out what's wrong with genpkglist

* Mon Jul 17 2023 tex - 0.5.15lorg3.95-22pclos2023
- rebuild against updates

* Wed Jul 05 2023 tex - 0.5.15lorg3.95-21pclos2023
- rebuild against updates

* Mon Jul 03 2023 yodelu - 0.5.15lorg3.95-20pclos2023
- more speed cache.. (rediff p228)

* Mon Jun 26 2023 tex - 0.5.15lorg3.95-19pclos2023
- rebuild
